#include "extrand_int.h"

/*this random function accepts a mean and a standard deviation and generates random
numbers that have those particular properties.*/
unsigned long __random_normal_028(unsigned long mean, unsigned long std_dev)
{
	unsigned short low = 0, high = 512, temp;
	
	temp = (unsigned short)__random_028(65536); /*pick a number*/
	
	while(low < high) /*do a binary search through the table for the number*/
	{
		unsigned short mid = (low + high) / 2;

		if(__norm_table[mid] < temp)
		{
			low = mid + 1;
		}
		else
		{
			high = mid;
		}
	}
	
	temp = std_dev * (unsigned long)low / 128; /*calculate the actual offset from the
	mean*/
	
	if(__random_028(2))
	{
		return(mean - temp);
	}
	else
	{
		return(mean + temp);
	}
}
