#define OPTIMIZE_ROM_CALLS
#define SAVE_SCREEN

#define USE_TI89

#include <tigcclib.h>

#include "vtilog.h"

#define RANDOM_STRENGTH 4

#if RANDOM_STRENGTH == 1
#define LENGTH 7
#define SEP 3
#elif RANDOM_STRENGTH == 2
#define LENGTH 15
#define SEP 1
#elif RANDOM_STRENGTH == 3
#define LENGTH 31
#define SEP 3
#elif RANDOM_STRENGTH == 4
#define LENGTH 63
#define SEP 1
#endif

unsigned long rand_state[LENGTH] = {};

void _main(void)
{
	short i, j;
	long rand_seed = 1, *fptr = &rand_state[0], *rptr = &rand_state[SEP],
	*end_ptr = &rand_state[LENGTH - 1];
	
	ClrScr();
	FontSetSys(F_4x6);

	for(i = 0; i < LENGTH; i++)
	{
		rand_state[i] = rand_seed = (rand_seed * 0x41C64E6D + 0x3039);
	}

	for(i = 0; i < LENGTH * 10; i++)
	{
	    *fptr += *rptr;
	    fptr++;
		rptr++;
		if(fptr > end_ptr)
		{
			fptr = &rand_state[0];
		}
		if(rptr > end_ptr)
		{
			rptr = &rand_state[0];
		}
	}

	for(j = 0; j < LENGTH; j++)
	{
		dbg_printf("0x%08lX, ", rand_state[j]);
	}
}
